// Code generated by entc, DO NOT EDIT.

package license

import (
	"entgo.io/ent"
)

const (
	// Label holds the string label denoting the license type in the database.
	Label = "license"
	// FieldID holds the string denoting the id field in the database.
	FieldID = "id"
	// FieldLicenseID holds the string denoting the license_id field in the database.
	FieldLicenseID = "license_id"
	// FieldName holds the string denoting the name field in the database.
	FieldName = "name"
	// EdgeOwner holds the string denoting the owner edge name in mutations.
	EdgeOwner = "owner"
	// EdgeSpdx holds the string denoting the spdx edge name in mutations.
	EdgeSpdx = "spdx"
	// EdgeComponents holds the string denoting the components edge name in mutations.
	EdgeComponents = "components"
	// EdgeInstances holds the string denoting the instances edge name in mutations.
	EdgeInstances = "instances"
	// Table holds the table name of the license in the database.
	Table = "license"
	// OwnerTable is the table that holds the owner relation/edge.
	OwnerTable = "license"
	// OwnerInverseTable is the table name for the Organization entity.
	// It exists in this package in order to avoid circular dependency with the "organization" package.
	OwnerInverseTable = "organization"
	// OwnerColumn is the table column denoting the owner relation/edge.
	OwnerColumn = "license_owner"
	// SpdxTable is the table that holds the spdx relation/edge.
	SpdxTable = "license"
	// SpdxInverseTable is the table name for the SPDXLicense entity.
	// It exists in this package in order to avoid circular dependency with the "spdxlicense" package.
	SpdxInverseTable = "spdx_license"
	// SpdxColumn is the table column denoting the spdx relation/edge.
	SpdxColumn = "license_spdx"
	// ComponentsTable is the table that holds the components relation/edge. The primary key declared below.
	ComponentsTable = "component_licenses"
	// ComponentsInverseTable is the table name for the Component entity.
	// It exists in this package in order to avoid circular dependency with the "component" package.
	ComponentsInverseTable = "component"
	// InstancesTable is the table that holds the instances relation/edge.
	InstancesTable = "release_license"
	// InstancesInverseTable is the table name for the ReleaseLicense entity.
	// It exists in this package in order to avoid circular dependency with the "releaselicense" package.
	InstancesInverseTable = "release_license"
	// InstancesColumn is the table column denoting the instances relation/edge.
	InstancesColumn = "release_license_license"
)

// Columns holds all SQL columns for license fields.
var Columns = []string{
	FieldID,
	FieldLicenseID,
	FieldName,
}

// ForeignKeys holds the SQL foreign-keys that are owned by the "license"
// table and are not defined as standalone fields in the schema.
var ForeignKeys = []string{
	"license_owner",
	"license_spdx",
}

var (
	// ComponentsPrimaryKey and ComponentsColumn2 are the table columns denoting the
	// primary key for the components relation (M2M).
	ComponentsPrimaryKey = []string{"component_id", "license_id"}
)

// ValidColumn reports if the column name is valid (part of the table columns).
func ValidColumn(column string) bool {
	for i := range Columns {
		if column == Columns[i] {
			return true
		}
	}
	for i := range ForeignKeys {
		if column == ForeignKeys[i] {
			return true
		}
	}
	return false
}

// Note that the variables below are initialized by the runtime
// package on the initialization of the application. Therefore,
// it should be imported in the main as follows:
//
//	import _ "github.com/valocode/bubbly/ent/runtime"
//
var (
	Hooks [1]ent.Hook
	// LicenseIDValidator is a validator for the "license_id" field. It is called by the builders before save.
	LicenseIDValidator func(string) error
)
