// Code generated by entc, DO NOT EDIT.

package release

import (
	"entgo.io/ent"
)

const (
	// Label holds the string label denoting the release type in the database.
	Label = "release"
	// FieldID holds the string denoting the id field in the database.
	FieldID = "id"
	// FieldName holds the string denoting the name field in the database.
	FieldName = "name"
	// FieldVersion holds the string denoting the version field in the database.
	FieldVersion = "version"
	// EdgeSubreleases holds the string denoting the subreleases edge name in mutations.
	EdgeSubreleases = "subreleases"
	// EdgeDependencies holds the string denoting the dependencies edge name in mutations.
	EdgeDependencies = "dependencies"
	// EdgeCommit holds the string denoting the commit edge name in mutations.
	EdgeCommit = "commit"
	// EdgeHeadOf holds the string denoting the head_of edge name in mutations.
	EdgeHeadOf = "head_of"
	// EdgeLog holds the string denoting the log edge name in mutations.
	EdgeLog = "log"
	// EdgeViolations holds the string denoting the violations edge name in mutations.
	EdgeViolations = "violations"
	// EdgeArtifacts holds the string denoting the artifacts edge name in mutations.
	EdgeArtifacts = "artifacts"
	// EdgeComponents holds the string denoting the components edge name in mutations.
	EdgeComponents = "components"
	// EdgeVulnerabilities holds the string denoting the vulnerabilities edge name in mutations.
	EdgeVulnerabilities = "vulnerabilities"
	// EdgeLicenses holds the string denoting the licenses edge name in mutations.
	EdgeLicenses = "licenses"
	// EdgeCodeScans holds the string denoting the code_scans edge name in mutations.
	EdgeCodeScans = "code_scans"
	// EdgeTestRuns holds the string denoting the test_runs edge name in mutations.
	EdgeTestRuns = "test_runs"
	// EdgeVulnerabilityReviews holds the string denoting the vulnerability_reviews edge name in mutations.
	EdgeVulnerabilityReviews = "vulnerability_reviews"
	// Table holds the table name of the release in the database.
	Table = "release"
	// SubreleasesTable is the table that holds the subreleases relation/edge. The primary key declared below.
	SubreleasesTable = "release_dependencies"
	// DependenciesTable is the table that holds the dependencies relation/edge. The primary key declared below.
	DependenciesTable = "release_dependencies"
	// CommitTable is the table that holds the commit relation/edge.
	CommitTable = "release"
	// CommitInverseTable is the table name for the GitCommit entity.
	// It exists in this package in order to avoid circular dependency with the "gitcommit" package.
	CommitInverseTable = "commit"
	// CommitColumn is the table column denoting the commit relation/edge.
	CommitColumn = "git_commit_release"
	// HeadOfTable is the table that holds the head_of relation/edge.
	HeadOfTable = "release"
	// HeadOfInverseTable is the table name for the Repo entity.
	// It exists in this package in order to avoid circular dependency with the "repo" package.
	HeadOfInverseTable = "repo"
	// HeadOfColumn is the table column denoting the head_of relation/edge.
	HeadOfColumn = "repo_head"
	// LogTable is the table that holds the log relation/edge.
	LogTable = "release_entry"
	// LogInverseTable is the table name for the ReleaseEntry entity.
	// It exists in this package in order to avoid circular dependency with the "releaseentry" package.
	LogInverseTable = "release_entry"
	// LogColumn is the table column denoting the log relation/edge.
	LogColumn = "release_entry_release"
	// ViolationsTable is the table that holds the violations relation/edge.
	ViolationsTable = "release_policy_violation"
	// ViolationsInverseTable is the table name for the ReleasePolicyViolation entity.
	// It exists in this package in order to avoid circular dependency with the "releasepolicyviolation" package.
	ViolationsInverseTable = "release_policy_violation"
	// ViolationsColumn is the table column denoting the violations relation/edge.
	ViolationsColumn = "release_policy_violation_release"
	// ArtifactsTable is the table that holds the artifacts relation/edge.
	ArtifactsTable = "artifact"
	// ArtifactsInverseTable is the table name for the Artifact entity.
	// It exists in this package in order to avoid circular dependency with the "artifact" package.
	ArtifactsInverseTable = "artifact"
	// ArtifactsColumn is the table column denoting the artifacts relation/edge.
	ArtifactsColumn = "artifact_release"
	// ComponentsTable is the table that holds the components relation/edge.
	ComponentsTable = "release_component"
	// ComponentsInverseTable is the table name for the ReleaseComponent entity.
	// It exists in this package in order to avoid circular dependency with the "releasecomponent" package.
	ComponentsInverseTable = "release_component"
	// ComponentsColumn is the table column denoting the components relation/edge.
	ComponentsColumn = "release_component_release"
	// VulnerabilitiesTable is the table that holds the vulnerabilities relation/edge.
	VulnerabilitiesTable = "release_vulnerability"
	// VulnerabilitiesInverseTable is the table name for the ReleaseVulnerability entity.
	// It exists in this package in order to avoid circular dependency with the "releasevulnerability" package.
	VulnerabilitiesInverseTable = "release_vulnerability"
	// VulnerabilitiesColumn is the table column denoting the vulnerabilities relation/edge.
	VulnerabilitiesColumn = "release_vulnerability_release"
	// LicensesTable is the table that holds the licenses relation/edge.
	LicensesTable = "release_license"
	// LicensesInverseTable is the table name for the ReleaseLicense entity.
	// It exists in this package in order to avoid circular dependency with the "releaselicense" package.
	LicensesInverseTable = "release_license"
	// LicensesColumn is the table column denoting the licenses relation/edge.
	LicensesColumn = "release_license_release"
	// CodeScansTable is the table that holds the code_scans relation/edge.
	CodeScansTable = "code_scan"
	// CodeScansInverseTable is the table name for the CodeScan entity.
	// It exists in this package in order to avoid circular dependency with the "codescan" package.
	CodeScansInverseTable = "code_scan"
	// CodeScansColumn is the table column denoting the code_scans relation/edge.
	CodeScansColumn = "code_scan_release"
	// TestRunsTable is the table that holds the test_runs relation/edge.
	TestRunsTable = "test_run"
	// TestRunsInverseTable is the table name for the TestRun entity.
	// It exists in this package in order to avoid circular dependency with the "testrun" package.
	TestRunsInverseTable = "test_run"
	// TestRunsColumn is the table column denoting the test_runs relation/edge.
	TestRunsColumn = "test_run_release"
	// VulnerabilityReviewsTable is the table that holds the vulnerability_reviews relation/edge. The primary key declared below.
	VulnerabilityReviewsTable = "vulnerability_review_releases"
	// VulnerabilityReviewsInverseTable is the table name for the VulnerabilityReview entity.
	// It exists in this package in order to avoid circular dependency with the "vulnerabilityreview" package.
	VulnerabilityReviewsInverseTable = "vulnerability_review"
)

// Columns holds all SQL columns for release fields.
var Columns = []string{
	FieldID,
	FieldName,
	FieldVersion,
}

// ForeignKeys holds the SQL foreign-keys that are owned by the "release"
// table and are not defined as standalone fields in the schema.
var ForeignKeys = []string{
	"git_commit_release",
	"repo_head",
}

var (
	// SubreleasesPrimaryKey and SubreleasesColumn2 are the table columns denoting the
	// primary key for the subreleases relation (M2M).
	SubreleasesPrimaryKey = []string{"release_id", "subrelease_id"}
	// DependenciesPrimaryKey and DependenciesColumn2 are the table columns denoting the
	// primary key for the dependencies relation (M2M).
	DependenciesPrimaryKey = []string{"release_id", "subrelease_id"}
	// VulnerabilityReviewsPrimaryKey and VulnerabilityReviewsColumn2 are the table columns denoting the
	// primary key for the vulnerability_reviews relation (M2M).
	VulnerabilityReviewsPrimaryKey = []string{"vulnerability_review_id", "release_id"}
)

// ValidColumn reports if the column name is valid (part of the table columns).
func ValidColumn(column string) bool {
	for i := range Columns {
		if column == Columns[i] {
			return true
		}
	}
	for i := range ForeignKeys {
		if column == ForeignKeys[i] {
			return true
		}
	}
	return false
}

// Note that the variables below are initialized by the runtime
// package on the initialization of the application. Therefore,
// it should be imported in the main as follows:
//
//	import _ "github.com/valocode/bubbly/ent/runtime"
//
var (
	Hooks [1]ent.Hook
	// NameValidator is a validator for the "name" field. It is called by the builders before save.
	NameValidator func(string) error
	// VersionValidator is a validator for the "version" field. It is called by the builders before save.
	VersionValidator func(string) error
)
