// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/valocode/bubbly/ent/predicate"
	"github.com/valocode/bubbly/ent/releasepolicy"
)

// ReleasePolicyDelete is the builder for deleting a ReleasePolicy entity.
type ReleasePolicyDelete struct {
	config
	hooks    []Hook
	mutation *ReleasePolicyMutation
}

// Where appends a list predicates to the ReleasePolicyDelete builder.
func (rpd *ReleasePolicyDelete) Where(ps ...predicate.ReleasePolicy) *ReleasePolicyDelete {
	rpd.mutation.Where(ps...)
	return rpd
}

// Exec executes the deletion query and returns how many vertices were deleted.
func (rpd *ReleasePolicyDelete) Exec(ctx context.Context) (int, error) {
	var (
		err      error
		affected int
	)
	if len(rpd.hooks) == 0 {
		affected, err = rpd.sqlExec(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*ReleasePolicyMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			rpd.mutation = mutation
			affected, err = rpd.sqlExec(ctx)
			mutation.done = true
			return affected, err
		})
		for i := len(rpd.hooks) - 1; i >= 0; i-- {
			if rpd.hooks[i] == nil {
				return 0, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = rpd.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, rpd.mutation); err != nil {
			return 0, err
		}
	}
	return affected, err
}

// ExecX is like Exec, but panics if an error occurs.
func (rpd *ReleasePolicyDelete) ExecX(ctx context.Context) int {
	n, err := rpd.Exec(ctx)
	if err != nil {
		panic(err)
	}
	return n
}

func (rpd *ReleasePolicyDelete) sqlExec(ctx context.Context) (int, error) {
	_spec := &sqlgraph.DeleteSpec{
		Node: &sqlgraph.NodeSpec{
			Table: releasepolicy.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: releasepolicy.FieldID,
			},
		},
	}
	if ps := rpd.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return sqlgraph.DeleteNodes(ctx, rpd.driver, _spec)
}

// ReleasePolicyDeleteOne is the builder for deleting a single ReleasePolicy entity.
type ReleasePolicyDeleteOne struct {
	rpd *ReleasePolicyDelete
}

// Exec executes the deletion query.
func (rpdo *ReleasePolicyDeleteOne) Exec(ctx context.Context) error {
	n, err := rpdo.rpd.Exec(ctx)
	switch {
	case err != nil:
		return err
	case n == 0:
		return &NotFoundError{releasepolicy.Label}
	default:
		return nil
	}
}

// ExecX is like Exec, but panics if an error occurs.
func (rpdo *ReleasePolicyDeleteOne) ExecX(ctx context.Context) {
	rpdo.rpd.ExecX(ctx)
}
