// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"database/sql/driver"
	"errors"
	"fmt"
	"math"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/valocode/bubbly/ent/predicate"
	"github.com/valocode/bubbly/ent/release"
	"github.com/valocode/bubbly/ent/releaseentry"
	"github.com/valocode/bubbly/ent/testcase"
	"github.com/valocode/bubbly/ent/testrun"
)

// TestRunQuery is the builder for querying TestRun entities.
type TestRunQuery struct {
	config
	limit      *int
	offset     *int
	unique     *bool
	order      []OrderFunc
	fields     []string
	predicates []predicate.TestRun
	// eager-loading edges.
	withRelease *ReleaseQuery
	withEntry   *ReleaseEntryQuery
	withTests   *TestCaseQuery
	withFKs     bool
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the TestRunQuery builder.
func (trq *TestRunQuery) Where(ps ...predicate.TestRun) *TestRunQuery {
	trq.predicates = append(trq.predicates, ps...)
	return trq
}

// Limit adds a limit step to the query.
func (trq *TestRunQuery) Limit(limit int) *TestRunQuery {
	trq.limit = &limit
	return trq
}

// Offset adds an offset step to the query.
func (trq *TestRunQuery) Offset(offset int) *TestRunQuery {
	trq.offset = &offset
	return trq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (trq *TestRunQuery) Unique(unique bool) *TestRunQuery {
	trq.unique = &unique
	return trq
}

// Order adds an order step to the query.
func (trq *TestRunQuery) Order(o ...OrderFunc) *TestRunQuery {
	trq.order = append(trq.order, o...)
	return trq
}

// QueryRelease chains the current query on the "release" edge.
func (trq *TestRunQuery) QueryRelease() *ReleaseQuery {
	query := &ReleaseQuery{config: trq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := trq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := trq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(testrun.Table, testrun.FieldID, selector),
			sqlgraph.To(release.Table, release.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, false, testrun.ReleaseTable, testrun.ReleaseColumn),
		)
		fromU = sqlgraph.SetNeighbors(trq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// QueryEntry chains the current query on the "entry" edge.
func (trq *TestRunQuery) QueryEntry() *ReleaseEntryQuery {
	query := &ReleaseEntryQuery{config: trq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := trq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := trq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(testrun.Table, testrun.FieldID, selector),
			sqlgraph.To(releaseentry.Table, releaseentry.FieldID),
			sqlgraph.Edge(sqlgraph.O2O, true, testrun.EntryTable, testrun.EntryColumn),
		)
		fromU = sqlgraph.SetNeighbors(trq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// QueryTests chains the current query on the "tests" edge.
func (trq *TestRunQuery) QueryTests() *TestCaseQuery {
	query := &TestCaseQuery{config: trq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := trq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := trq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(testrun.Table, testrun.FieldID, selector),
			sqlgraph.To(testcase.Table, testcase.FieldID),
			sqlgraph.Edge(sqlgraph.O2M, true, testrun.TestsTable, testrun.TestsColumn),
		)
		fromU = sqlgraph.SetNeighbors(trq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// First returns the first TestRun entity from the query.
// Returns a *NotFoundError when no TestRun was found.
func (trq *TestRunQuery) First(ctx context.Context) (*TestRun, error) {
	nodes, err := trq.Limit(1).All(ctx)
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{testrun.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (trq *TestRunQuery) FirstX(ctx context.Context) *TestRun {
	node, err := trq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first TestRun ID from the query.
// Returns a *NotFoundError when no TestRun ID was found.
func (trq *TestRunQuery) FirstID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = trq.Limit(1).IDs(ctx); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{testrun.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (trq *TestRunQuery) FirstIDX(ctx context.Context) int {
	id, err := trq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single TestRun entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when exactly one TestRun entity is not found.
// Returns a *NotFoundError when no TestRun entities are found.
func (trq *TestRunQuery) Only(ctx context.Context) (*TestRun, error) {
	nodes, err := trq.Limit(2).All(ctx)
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{testrun.Label}
	default:
		return nil, &NotSingularError{testrun.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (trq *TestRunQuery) OnlyX(ctx context.Context) *TestRun {
	node, err := trq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only TestRun ID in the query.
// Returns a *NotSingularError when exactly one TestRun ID is not found.
// Returns a *NotFoundError when no entities are found.
func (trq *TestRunQuery) OnlyID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = trq.Limit(2).IDs(ctx); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{testrun.Label}
	default:
		err = &NotSingularError{testrun.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (trq *TestRunQuery) OnlyIDX(ctx context.Context) int {
	id, err := trq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of TestRuns.
func (trq *TestRunQuery) All(ctx context.Context) ([]*TestRun, error) {
	if err := trq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	return trq.sqlAll(ctx)
}

// AllX is like All, but panics if an error occurs.
func (trq *TestRunQuery) AllX(ctx context.Context) []*TestRun {
	nodes, err := trq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of TestRun IDs.
func (trq *TestRunQuery) IDs(ctx context.Context) ([]int, error) {
	var ids []int
	if err := trq.Select(testrun.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (trq *TestRunQuery) IDsX(ctx context.Context) []int {
	ids, err := trq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (trq *TestRunQuery) Count(ctx context.Context) (int, error) {
	if err := trq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return trq.sqlCount(ctx)
}

// CountX is like Count, but panics if an error occurs.
func (trq *TestRunQuery) CountX(ctx context.Context) int {
	count, err := trq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (trq *TestRunQuery) Exist(ctx context.Context) (bool, error) {
	if err := trq.prepareQuery(ctx); err != nil {
		return false, err
	}
	return trq.sqlExist(ctx)
}

// ExistX is like Exist, but panics if an error occurs.
func (trq *TestRunQuery) ExistX(ctx context.Context) bool {
	exist, err := trq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the TestRunQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (trq *TestRunQuery) Clone() *TestRunQuery {
	if trq == nil {
		return nil
	}
	return &TestRunQuery{
		config:      trq.config,
		limit:       trq.limit,
		offset:      trq.offset,
		order:       append([]OrderFunc{}, trq.order...),
		predicates:  append([]predicate.TestRun{}, trq.predicates...),
		withRelease: trq.withRelease.Clone(),
		withEntry:   trq.withEntry.Clone(),
		withTests:   trq.withTests.Clone(),
		// clone intermediate query.
		sql:  trq.sql.Clone(),
		path: trq.path,
	}
}

// WithRelease tells the query-builder to eager-load the nodes that are connected to
// the "release" edge. The optional arguments are used to configure the query builder of the edge.
func (trq *TestRunQuery) WithRelease(opts ...func(*ReleaseQuery)) *TestRunQuery {
	query := &ReleaseQuery{config: trq.config}
	for _, opt := range opts {
		opt(query)
	}
	trq.withRelease = query
	return trq
}

// WithEntry tells the query-builder to eager-load the nodes that are connected to
// the "entry" edge. The optional arguments are used to configure the query builder of the edge.
func (trq *TestRunQuery) WithEntry(opts ...func(*ReleaseEntryQuery)) *TestRunQuery {
	query := &ReleaseEntryQuery{config: trq.config}
	for _, opt := range opts {
		opt(query)
	}
	trq.withEntry = query
	return trq
}

// WithTests tells the query-builder to eager-load the nodes that are connected to
// the "tests" edge. The optional arguments are used to configure the query builder of the edge.
func (trq *TestRunQuery) WithTests(opts ...func(*TestCaseQuery)) *TestRunQuery {
	query := &TestCaseQuery{config: trq.config}
	for _, opt := range opts {
		opt(query)
	}
	trq.withTests = query
	return trq
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		Tool string `json:"tool,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.TestRun.Query().
//		GroupBy(testrun.FieldTool).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
//
func (trq *TestRunQuery) GroupBy(field string, fields ...string) *TestRunGroupBy {
	group := &TestRunGroupBy{config: trq.config}
	group.fields = append([]string{field}, fields...)
	group.path = func(ctx context.Context) (prev *sql.Selector, err error) {
		if err := trq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		return trq.sqlQuery(ctx), nil
	}
	return group
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		Tool string `json:"tool,omitempty"`
//	}
//
//	client.TestRun.Query().
//		Select(testrun.FieldTool).
//		Scan(ctx, &v)
//
func (trq *TestRunQuery) Select(fields ...string) *TestRunSelect {
	trq.fields = append(trq.fields, fields...)
	return &TestRunSelect{TestRunQuery: trq}
}

func (trq *TestRunQuery) prepareQuery(ctx context.Context) error {
	for _, f := range trq.fields {
		if !testrun.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if trq.path != nil {
		prev, err := trq.path(ctx)
		if err != nil {
			return err
		}
		trq.sql = prev
	}
	return nil
}

func (trq *TestRunQuery) sqlAll(ctx context.Context) ([]*TestRun, error) {
	var (
		nodes       = []*TestRun{}
		withFKs     = trq.withFKs
		_spec       = trq.querySpec()
		loadedTypes = [3]bool{
			trq.withRelease != nil,
			trq.withEntry != nil,
			trq.withTests != nil,
		}
	)
	if trq.withRelease != nil || trq.withEntry != nil {
		withFKs = true
	}
	if withFKs {
		_spec.Node.Columns = append(_spec.Node.Columns, testrun.ForeignKeys...)
	}
	_spec.ScanValues = func(columns []string) ([]interface{}, error) {
		node := &TestRun{config: trq.config}
		nodes = append(nodes, node)
		return node.scanValues(columns)
	}
	_spec.Assign = func(columns []string, values []interface{}) error {
		if len(nodes) == 0 {
			return fmt.Errorf("ent: Assign called without calling ScanValues")
		}
		node := nodes[len(nodes)-1]
		node.Edges.loadedTypes = loadedTypes
		return node.assignValues(columns, values)
	}
	if err := sqlgraph.QueryNodes(ctx, trq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}

	if query := trq.withRelease; query != nil {
		ids := make([]int, 0, len(nodes))
		nodeids := make(map[int][]*TestRun)
		for i := range nodes {
			if nodes[i].test_run_release == nil {
				continue
			}
			fk := *nodes[i].test_run_release
			if _, ok := nodeids[fk]; !ok {
				ids = append(ids, fk)
			}
			nodeids[fk] = append(nodeids[fk], nodes[i])
		}
		query.Where(release.IDIn(ids...))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			nodes, ok := nodeids[n.ID]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "test_run_release" returned %v`, n.ID)
			}
			for i := range nodes {
				nodes[i].Edges.Release = n
			}
		}
	}

	if query := trq.withEntry; query != nil {
		ids := make([]int, 0, len(nodes))
		nodeids := make(map[int][]*TestRun)
		for i := range nodes {
			if nodes[i].release_entry_test_run == nil {
				continue
			}
			fk := *nodes[i].release_entry_test_run
			if _, ok := nodeids[fk]; !ok {
				ids = append(ids, fk)
			}
			nodeids[fk] = append(nodeids[fk], nodes[i])
		}
		query.Where(releaseentry.IDIn(ids...))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			nodes, ok := nodeids[n.ID]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "release_entry_test_run" returned %v`, n.ID)
			}
			for i := range nodes {
				nodes[i].Edges.Entry = n
			}
		}
	}

	if query := trq.withTests; query != nil {
		fks := make([]driver.Value, 0, len(nodes))
		nodeids := make(map[int]*TestRun)
		for i := range nodes {
			fks = append(fks, nodes[i].ID)
			nodeids[nodes[i].ID] = nodes[i]
			nodes[i].Edges.Tests = []*TestCase{}
		}
		query.withFKs = true
		query.Where(predicate.TestCase(func(s *sql.Selector) {
			s.Where(sql.InValues(testrun.TestsColumn, fks...))
		}))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			fk := n.test_case_run
			if fk == nil {
				return nil, fmt.Errorf(`foreign-key "test_case_run" is nil for node %v`, n.ID)
			}
			node, ok := nodeids[*fk]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "test_case_run" returned %v for node %v`, *fk, n.ID)
			}
			node.Edges.Tests = append(node.Edges.Tests, n)
		}
	}

	return nodes, nil
}

func (trq *TestRunQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := trq.querySpec()
	return sqlgraph.CountNodes(ctx, trq.driver, _spec)
}

func (trq *TestRunQuery) sqlExist(ctx context.Context) (bool, error) {
	n, err := trq.sqlCount(ctx)
	if err != nil {
		return false, fmt.Errorf("ent: check existence: %w", err)
	}
	return n > 0, nil
}

func (trq *TestRunQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := &sqlgraph.QuerySpec{
		Node: &sqlgraph.NodeSpec{
			Table:   testrun.Table,
			Columns: testrun.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: testrun.FieldID,
			},
		},
		From:   trq.sql,
		Unique: true,
	}
	if unique := trq.unique; unique != nil {
		_spec.Unique = *unique
	}
	if fields := trq.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, testrun.FieldID)
		for i := range fields {
			if fields[i] != testrun.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
	}
	if ps := trq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := trq.limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := trq.offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := trq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (trq *TestRunQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(trq.driver.Dialect())
	t1 := builder.Table(testrun.Table)
	columns := trq.fields
	if len(columns) == 0 {
		columns = testrun.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if trq.sql != nil {
		selector = trq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	for _, p := range trq.predicates {
		p(selector)
	}
	for _, p := range trq.order {
		p(selector)
	}
	if offset := trq.offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := trq.limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// TestRunGroupBy is the group-by builder for TestRun entities.
type TestRunGroupBy struct {
	config
	fields []string
	fns    []AggregateFunc
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Aggregate adds the given aggregation functions to the group-by query.
func (trgb *TestRunGroupBy) Aggregate(fns ...AggregateFunc) *TestRunGroupBy {
	trgb.fns = append(trgb.fns, fns...)
	return trgb
}

// Scan applies the group-by query and scans the result into the given value.
func (trgb *TestRunGroupBy) Scan(ctx context.Context, v interface{}) error {
	query, err := trgb.path(ctx)
	if err != nil {
		return err
	}
	trgb.sql = query
	return trgb.sqlScan(ctx, v)
}

// ScanX is like Scan, but panics if an error occurs.
func (trgb *TestRunGroupBy) ScanX(ctx context.Context, v interface{}) {
	if err := trgb.Scan(ctx, v); err != nil {
		panic(err)
	}
}

// Strings returns list of strings from group-by.
// It is only allowed when executing a group-by query with one field.
func (trgb *TestRunGroupBy) Strings(ctx context.Context) ([]string, error) {
	if len(trgb.fields) > 1 {
		return nil, errors.New("ent: TestRunGroupBy.Strings is not achievable when grouping more than 1 field")
	}
	var v []string
	if err := trgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// StringsX is like Strings, but panics if an error occurs.
func (trgb *TestRunGroupBy) StringsX(ctx context.Context) []string {
	v, err := trgb.Strings(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// String returns a single string from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (trgb *TestRunGroupBy) String(ctx context.Context) (_ string, err error) {
	var v []string
	if v, err = trgb.Strings(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{testrun.Label}
	default:
		err = fmt.Errorf("ent: TestRunGroupBy.Strings returned %d results when one was expected", len(v))
	}
	return
}

// StringX is like String, but panics if an error occurs.
func (trgb *TestRunGroupBy) StringX(ctx context.Context) string {
	v, err := trgb.String(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Ints returns list of ints from group-by.
// It is only allowed when executing a group-by query with one field.
func (trgb *TestRunGroupBy) Ints(ctx context.Context) ([]int, error) {
	if len(trgb.fields) > 1 {
		return nil, errors.New("ent: TestRunGroupBy.Ints is not achievable when grouping more than 1 field")
	}
	var v []int
	if err := trgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// IntsX is like Ints, but panics if an error occurs.
func (trgb *TestRunGroupBy) IntsX(ctx context.Context) []int {
	v, err := trgb.Ints(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Int returns a single int from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (trgb *TestRunGroupBy) Int(ctx context.Context) (_ int, err error) {
	var v []int
	if v, err = trgb.Ints(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{testrun.Label}
	default:
		err = fmt.Errorf("ent: TestRunGroupBy.Ints returned %d results when one was expected", len(v))
	}
	return
}

// IntX is like Int, but panics if an error occurs.
func (trgb *TestRunGroupBy) IntX(ctx context.Context) int {
	v, err := trgb.Int(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64s returns list of float64s from group-by.
// It is only allowed when executing a group-by query with one field.
func (trgb *TestRunGroupBy) Float64s(ctx context.Context) ([]float64, error) {
	if len(trgb.fields) > 1 {
		return nil, errors.New("ent: TestRunGroupBy.Float64s is not achievable when grouping more than 1 field")
	}
	var v []float64
	if err := trgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// Float64sX is like Float64s, but panics if an error occurs.
func (trgb *TestRunGroupBy) Float64sX(ctx context.Context) []float64 {
	v, err := trgb.Float64s(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64 returns a single float64 from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (trgb *TestRunGroupBy) Float64(ctx context.Context) (_ float64, err error) {
	var v []float64
	if v, err = trgb.Float64s(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{testrun.Label}
	default:
		err = fmt.Errorf("ent: TestRunGroupBy.Float64s returned %d results when one was expected", len(v))
	}
	return
}

// Float64X is like Float64, but panics if an error occurs.
func (trgb *TestRunGroupBy) Float64X(ctx context.Context) float64 {
	v, err := trgb.Float64(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bools returns list of bools from group-by.
// It is only allowed when executing a group-by query with one field.
func (trgb *TestRunGroupBy) Bools(ctx context.Context) ([]bool, error) {
	if len(trgb.fields) > 1 {
		return nil, errors.New("ent: TestRunGroupBy.Bools is not achievable when grouping more than 1 field")
	}
	var v []bool
	if err := trgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// BoolsX is like Bools, but panics if an error occurs.
func (trgb *TestRunGroupBy) BoolsX(ctx context.Context) []bool {
	v, err := trgb.Bools(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bool returns a single bool from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (trgb *TestRunGroupBy) Bool(ctx context.Context) (_ bool, err error) {
	var v []bool
	if v, err = trgb.Bools(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{testrun.Label}
	default:
		err = fmt.Errorf("ent: TestRunGroupBy.Bools returned %d results when one was expected", len(v))
	}
	return
}

// BoolX is like Bool, but panics if an error occurs.
func (trgb *TestRunGroupBy) BoolX(ctx context.Context) bool {
	v, err := trgb.Bool(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

func (trgb *TestRunGroupBy) sqlScan(ctx context.Context, v interface{}) error {
	for _, f := range trgb.fields {
		if !testrun.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("invalid field %q for group-by", f)}
		}
	}
	selector := trgb.sqlQuery()
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := trgb.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

func (trgb *TestRunGroupBy) sqlQuery() *sql.Selector {
	selector := trgb.sql.Select()
	aggregation := make([]string, 0, len(trgb.fns))
	for _, fn := range trgb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	// If no columns were selected in a custom aggregation function, the default
	// selection is the fields used for "group-by", and the aggregation functions.
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(trgb.fields)+len(trgb.fns))
		for _, f := range trgb.fields {
			columns = append(columns, selector.C(f))
		}
		for _, c := range aggregation {
			columns = append(columns, c)
		}
		selector.Select(columns...)
	}
	return selector.GroupBy(selector.Columns(trgb.fields...)...)
}

// TestRunSelect is the builder for selecting fields of TestRun entities.
type TestRunSelect struct {
	*TestRunQuery
	// intermediate query (i.e. traversal path).
	sql *sql.Selector
}

// Scan applies the selector query and scans the result into the given value.
func (trs *TestRunSelect) Scan(ctx context.Context, v interface{}) error {
	if err := trs.prepareQuery(ctx); err != nil {
		return err
	}
	trs.sql = trs.TestRunQuery.sqlQuery(ctx)
	return trs.sqlScan(ctx, v)
}

// ScanX is like Scan, but panics if an error occurs.
func (trs *TestRunSelect) ScanX(ctx context.Context, v interface{}) {
	if err := trs.Scan(ctx, v); err != nil {
		panic(err)
	}
}

// Strings returns list of strings from a selector. It is only allowed when selecting one field.
func (trs *TestRunSelect) Strings(ctx context.Context) ([]string, error) {
	if len(trs.fields) > 1 {
		return nil, errors.New("ent: TestRunSelect.Strings is not achievable when selecting more than 1 field")
	}
	var v []string
	if err := trs.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// StringsX is like Strings, but panics if an error occurs.
func (trs *TestRunSelect) StringsX(ctx context.Context) []string {
	v, err := trs.Strings(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// String returns a single string from a selector. It is only allowed when selecting one field.
func (trs *TestRunSelect) String(ctx context.Context) (_ string, err error) {
	var v []string
	if v, err = trs.Strings(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{testrun.Label}
	default:
		err = fmt.Errorf("ent: TestRunSelect.Strings returned %d results when one was expected", len(v))
	}
	return
}

// StringX is like String, but panics if an error occurs.
func (trs *TestRunSelect) StringX(ctx context.Context) string {
	v, err := trs.String(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Ints returns list of ints from a selector. It is only allowed when selecting one field.
func (trs *TestRunSelect) Ints(ctx context.Context) ([]int, error) {
	if len(trs.fields) > 1 {
		return nil, errors.New("ent: TestRunSelect.Ints is not achievable when selecting more than 1 field")
	}
	var v []int
	if err := trs.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// IntsX is like Ints, but panics if an error occurs.
func (trs *TestRunSelect) IntsX(ctx context.Context) []int {
	v, err := trs.Ints(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Int returns a single int from a selector. It is only allowed when selecting one field.
func (trs *TestRunSelect) Int(ctx context.Context) (_ int, err error) {
	var v []int
	if v, err = trs.Ints(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{testrun.Label}
	default:
		err = fmt.Errorf("ent: TestRunSelect.Ints returned %d results when one was expected", len(v))
	}
	return
}

// IntX is like Int, but panics if an error occurs.
func (trs *TestRunSelect) IntX(ctx context.Context) int {
	v, err := trs.Int(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64s returns list of float64s from a selector. It is only allowed when selecting one field.
func (trs *TestRunSelect) Float64s(ctx context.Context) ([]float64, error) {
	if len(trs.fields) > 1 {
		return nil, errors.New("ent: TestRunSelect.Float64s is not achievable when selecting more than 1 field")
	}
	var v []float64
	if err := trs.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// Float64sX is like Float64s, but panics if an error occurs.
func (trs *TestRunSelect) Float64sX(ctx context.Context) []float64 {
	v, err := trs.Float64s(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64 returns a single float64 from a selector. It is only allowed when selecting one field.
func (trs *TestRunSelect) Float64(ctx context.Context) (_ float64, err error) {
	var v []float64
	if v, err = trs.Float64s(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{testrun.Label}
	default:
		err = fmt.Errorf("ent: TestRunSelect.Float64s returned %d results when one was expected", len(v))
	}
	return
}

// Float64X is like Float64, but panics if an error occurs.
func (trs *TestRunSelect) Float64X(ctx context.Context) float64 {
	v, err := trs.Float64(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bools returns list of bools from a selector. It is only allowed when selecting one field.
func (trs *TestRunSelect) Bools(ctx context.Context) ([]bool, error) {
	if len(trs.fields) > 1 {
		return nil, errors.New("ent: TestRunSelect.Bools is not achievable when selecting more than 1 field")
	}
	var v []bool
	if err := trs.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// BoolsX is like Bools, but panics if an error occurs.
func (trs *TestRunSelect) BoolsX(ctx context.Context) []bool {
	v, err := trs.Bools(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bool returns a single bool from a selector. It is only allowed when selecting one field.
func (trs *TestRunSelect) Bool(ctx context.Context) (_ bool, err error) {
	var v []bool
	if v, err = trs.Bools(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{testrun.Label}
	default:
		err = fmt.Errorf("ent: TestRunSelect.Bools returned %d results when one was expected", len(v))
	}
	return
}

// BoolX is like Bool, but panics if an error occurs.
func (trs *TestRunSelect) BoolX(ctx context.Context) bool {
	v, err := trs.Bool(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

func (trs *TestRunSelect) sqlScan(ctx context.Context, v interface{}) error {
	rows := &sql.Rows{}
	query, args := trs.sql.Query()
	if err := trs.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}
